'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _style = {
  "addImage": "draftJsEmojiPlugin__addImage__3u5YK",
  "addImagePopover": "draftJsEmojiPlugin__addImagePopover__1rdg_",
  "addImageClosedPopover": "draftJsEmojiPlugin__addImageClosedPopover__2de8k",
  "addImageBottomGradient": "draftJsEmojiPlugin__addImageBottomGradient__1MwjY",
  "addImageInput": "draftJsEmojiPlugin__addImageInput__OdVae",
  "addImageConfirmButton": "draftJsEmojiPlugin__addImageConfirmButton__2T4_d"
};

var _style2 = _interopRequireDefault(_style);

var _addImage = require('../modifiers/addImage');

var _addImage2 = _interopRequireDefault(_addImage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ImageAdd = function (_Component) {
  _inherits(ImageAdd, _Component);

  function ImageAdd() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ImageAdd);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ImageAdd.__proto__ || Object.getPrototypeOf(ImageAdd)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      url: '',
      open: false
    }, _this.onPopoverClick = function () {
      _this.preventNextClose = true;
    }, _this.openPopover = function () {
      if (!_this.state.open) {
        _this.preventNextClose = true;
        _this.setState({
          open: true
        });
      }
    }, _this.closePopover = function () {
      if (!_this.preventNextClose && _this.state.open) {
        _this.setState({
          open: false
        });
      }

      _this.preventNextClose = false;
    }, _this.addImage = function () {
      var _this$props = _this.props,
          editorState = _this$props.editorState,
          onChange = _this$props.onChange;

      onChange((0, _addImage2.default)(editorState, _this.state.url));
    }, _this.changeUrl = function (evt) {
      _this.setState({ url: evt.target.value });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }
  // Start the popover closed


  _createClass(ImageAdd, [{
    key: 'componentDidMount',


    // When the popover is open and users click anywhere on the page,
    // the popover should close
    value: function componentDidMount() {
      document.addEventListener('click', this.closePopover);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.closePopover);
    }

    // Note: make sure whenever a click happens within the popover it is not closed

  }, {
    key: 'render',
    value: function render() {
      var popoverClassName = this.state.open ? _style2.default.addImagePopover : _style2.default.addImageClosedPopover;

      return _react2.default.createElement(
        'div',
        { className: _style2.default.addImage },
        _react2.default.createElement(
          'div',
          {
            className: popoverClassName,
            onClick: this.onPopoverClick
          },
          _react2.default.createElement('input', {
            type: 'text',
            placeholder: 'Paste the image url \u2026',
            className: _style2.default.addImageInput,
            onChange: this.changeUrl,
            value: this.state.url
          }),
          _react2.default.createElement(
            'button',
            {
              className: _style2.default.addImageConfirmButton,
              type: 'button',
              onClick: this.addImage
            },
            'Add'
          )
        )
      );
    }
  }]);

  return ImageAdd;
}(_react.Component);

exports.default = ImageAdd;